import type { ExtractPropTypes, ToRefs } from 'vue';
export declare const useDelayedToggleProps: {
    /**
     * @description delay of appearance, in millisecond
     */
    readonly showAfter: {
        readonly type: NumberConstructor;
        readonly default: 0;
    };
    /**
     * @description delay of disappear, in millisecond
     */
    readonly hideAfter: {
        readonly type: NumberConstructor;
        readonly default: 200;
    };
    /**
     * @description disappear automatically, in millisecond
     */
    readonly autoClose: {
        readonly type: NumberConstructor;
        readonly default: 0;
    };
};
export type UseDelayedToggleProps = {
    open: (event?: Event) => void;
    close: (event?: Event) => void;
} & ToRefs<ExtractPropTypes<typeof useDelayedToggleProps>>;
export declare const useDelayedToggle: ({ showAfter, hideAfter, autoClose, open, close }: UseDelayedToggleProps) => any;
