import type { ExtractPropTypes, PropType, Ref } from 'vue';
declare const _prop: {
    readonly type: BooleanConstructor;
};
declare const _event: {
    readonly type: PropType<(val: boolean) => void>;
};
export type UseModelTogglePropsRaw<T extends string> = {
    [K in T]: typeof _prop;
} & {
    [K in `onUpdate:${T}`]: typeof _event;
};
export type UseModelTogglePropsGeneric<T extends string> = {
    [K in T]: ExtractPropTypes<typeof _prop>;
} & {
    [K in `onUpdate:${T}`]: ExtractPropTypes<typeof _event>;
};
export declare const createModelToggleComposable: <T extends string>(name: T) => any;
declare const useModelToggle: any, useModelToggleProps: any, useModelToggleEmits: any;
export { useModelToggle, useModelToggleEmits, useModelToggleProps };
export type UseModelToggleProps = ExtractPropTypes<typeof useModelToggleProps>;
export interface ModelToggleParams {
    indicator: Ref<boolean>;
    toggleReason?: Ref<Event | undefined>;
    shouldHideWhenRouteChanges?: Ref<boolean>;
    shouldProceed?: () => boolean;
    onShow?: (event?: Event) => void;
    onHide?: (event?: Event) => void;
}
