import { defineComponent as V, ref as j, provide as q, watch as C, unref as E, onMounted as x, onBeforeUnmount as z, nextTick as U } from "vue";
import { useFocusReason as J, tryFocus as f, createFocusOutPreventedEvent as m, getEdges as M, focusableStack as K, focusFirstDescendant as Y, obtainAllFocusableElements as G, isFocusCausedByUserEvent as H } from "./index3.js";
import { ON_TRAP_FOCUS_EVT as k, ON_RELEASE_FOCUS_EVT as N, FOCUS_TRAP_INJECTION_KEY as Q, FOCUS_AFTER_TRAPPED as O, FOCUS_AFTER_TRAPPED_OPTS as B, FOCUS_AFTER_RELEASED as b } from "./index4.js";
import { useEscapeKeydown as W } from "../../../hooks/index16.js";
import { isNil as X, isString as Z } from "../../../utils/lodash/index2.js";
import { EVENT_CODE as $ } from "../../../constants/index.js";
const ee = {
  loop: Boolean,
  trapped: Boolean,
  focusTrapEl: Object,
  focusStartEl: {
    type: [Object, String],
    default: "first"
  }
};
var ce = V({
  name: "FzFocusTrap",
  inheritAttrs: !1,
  props: ee,
  emits: [
    k,
    N,
    "focusin",
    "focusout",
    "focusout-prevented",
    "release-requested"
  ],
  setup(n, { emit: r }) {
    const c = j();
    let v, T;
    const { focusReason: d } = J();
    W((e) => {
      n.trapped && !i.paused && r("release-requested", e);
    });
    const i = {
      paused: !1,
      pause() {
        this.paused = !0;
      },
      resume() {
        this.paused = !1;
      }
    }, l = (e) => {
      if (!n.loop && !n.trapped || i.paused)
        return;
      const { key: t, altKey: s, ctrlKey: o, metaKey: a, currentTarget: h, shiftKey: D } = e, { loop: I } = n, w = t === $.tab && !s && !o && !a, p = document.activeElement;
      if (w && p) {
        const F = h, [P, _] = M(F);
        if (P && _) {
          if (!D && p === _) {
            const u = m({
              focusReason: d.value
            });
            r("focusout-prevented", u), u.defaultPrevented || (e.preventDefault(), I && f(P, !0));
          } else if (D && [P, F].includes(p)) {
            const u = m({
              focusReason: d.value
            });
            r("focusout-prevented", u), u.defaultPrevented || (e.preventDefault(), I && f(_, !0));
          }
        } else if (p === F) {
          const u = m({
            focusReason: d.value
          });
          r("focusout-prevented", u), u.defaultPrevented || e.preventDefault();
        }
      }
    };
    q(Q, {
      focusTrapRef: c,
      onKeydown: l
    }), C(
      () => n.focusTrapEl,
      (e) => {
        e && (c.value = e);
      },
      { immediate: !0 }
    ), C([c], ([e], [t]) => {
      e && (e.addEventListener("keydown", l), e.addEventListener("focusin", S), e.addEventListener("focusout", L)), t && (t.removeEventListener("keydown", l), t.removeEventListener("focusin", S), t.removeEventListener("focusout", L));
    });
    const y = (e) => {
      r(k, e);
    }, g = (e) => r(N, e), S = (e) => {
      const t = E(c);
      if (!t)
        return;
      const s = e.target, o = e.relatedTarget, a = s && t.contains(s);
      n.trapped || o && t.contains(o) || (v = o), a && r("focusin", e), !i.paused && n.trapped && (a ? T = s : f(T, !0));
    }, L = (e) => {
      const t = E(c);
      if (!(i.paused || !t))
        if (n.trapped) {
          const s = e.relatedTarget;
          !X(s) && !t.contains(s) && setTimeout(() => {
            if (!i.paused && n.trapped) {
              const o = m({
                focusReason: d.value
              });
              r("focusout-prevented", o), o.defaultPrevented || f(T, !0);
            }
          }, 0);
        } else {
          const s = e.target;
          s && t.contains(s) || r("focusout", e);
        }
    };
    async function A() {
      await U();
      const e = E(c);
      if (e) {
        K.push(i);
        const t = e.contains(document.activeElement) ? v : document.activeElement;
        if (v = t, !e.contains(t)) {
          const o = new Event(O, B);
          e.addEventListener(O, y), e.dispatchEvent(o), o.defaultPrevented || U(() => {
            let a = n.focusStartEl;
            Z(a) || (f(a), document.activeElement !== a && (a = "first")), a === "first" && Y(G(e), !0), (document.activeElement === t || a === "container") && f(e);
          });
        }
      }
    }
    function R() {
      const e = E(c);
      if (e) {
        e.removeEventListener(O, y);
        const t = new CustomEvent(b, {
          ...B,
          detail: {
            focusReason: d.value
          }
        });
        e.addEventListener(b, g), e.dispatchEvent(t), !t.defaultPrevented && (d.value == "keyboard" || !H() || e.contains(document.activeElement)) && f(v ?? document.body), e.removeEventListener(b, g), K.remove(i);
      }
    }
    return x(() => {
      n.trapped && A(), C(
        () => n.trapped,
        (e) => {
          e ? A() : R();
        }
      );
    }), z(() => {
      n.trapped && R();
    }), {
      onKeydown: l
    };
  }
});
export {
  ce as default
};
