import { popperContentProps as e } from "../../../popper/src/components/index2.js";
import { useDelayedToggleProps as t } from "../../../../hooks/index14.js";
const p = {
  ...t,
  ...e,
  /**
   * @description which element the tooltip CONTENT appends to
   */
  appendTo: {
    type: [String, Object]
  },
  /**
   * @description display content, can be overridden by `slot#content`
   */
  content: {
    type: String,
    default: ""
  },
  /**
   * @description whether `content` is treated as HTML string
   */
  rawContent: {
    type: Boolean,
    default: !1
  },
  /**
   * @description when tooltip inactive and `persistent` is `false` , popconfirm will be destroyed
   */
  persistent: Boolean,
  /**
   * @description same as `aria-label`
   */
  ariaLabel: String,
  // because model toggle prop is generated dynamically
  // so the typing cannot be evaluated by typescript as type:
  // [name]: { type: Boolean, default: null }
  // so we need to declare that again for type checking.
  /**
   * @description visibility of Tooltip
   * https://github.com/vuejs/vue/issues/4792#issuecomment-275396426
   */
  visible: {
    type: Boolean,
    default: void 0
  },
  /**
   * @description animation name
   */
  transition: String,
  /**
   * @description whether tooltip content is teleported, if `true` it will be teleported to where `append-to` sets
   */
  teleported: {
    type: Boolean,
    default: !0
  },
  /**
   * @description whether Tooltip is disabled
   */
  disabled: Boolean
};
export {
  p as useTooltipContentProps
};
