import type { IconSlotType } from '../..';
import type { ButtonType } from '..';
import type { DefineComponent, PropType, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
import type { Install } from '../../utils';
import Popconfirm from "./src/popconfirm";
export declare const FzPopconfirm: Install<DefineComponent<{
    readonly title: StringConstructor;
    readonly confirmButtonText: StringConstructor;
    readonly cancelButtonText: StringConstructor;
    readonly confirmButtonType: {
        readonly type: PropType<ButtonType>;
        readonly default: "primary";
    };
    readonly cancelButtonType: {
        readonly type: PropType<ButtonType>;
        readonly default: "text";
    };
    readonly icon: {
        readonly type: PropType<IconSlotType>;
        readonly default: () => any;
    };
    readonly iconColor: {
        readonly type: StringConstructor;
        readonly default: "#f90";
    };
    readonly hideIcon: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly hideAfter: {
        readonly type: NumberConstructor;
        readonly default: 200;
    };
    readonly teleported: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly persistent: BooleanConstructor;
    readonly width: {
        readonly type: PropType<string | number>;
        readonly default: 150;
    };
}, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    confirm: (e: MouseEvent) => boolean;
    cancel: (e: MouseEvent) => boolean;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly title: StringConstructor;
    readonly confirmButtonText: StringConstructor;
    readonly cancelButtonText: StringConstructor;
    readonly confirmButtonType: {
        readonly type: PropType<ButtonType>;
        readonly default: "primary";
    };
    readonly cancelButtonType: {
        readonly type: PropType<ButtonType>;
        readonly default: "text";
    };
    readonly icon: {
        readonly type: PropType<IconSlotType>;
        readonly default: () => any;
    };
    readonly iconColor: {
        readonly type: StringConstructor;
        readonly default: "#f90";
    };
    readonly hideIcon: {
        readonly type: BooleanConstructor;
        readonly default: false;
    };
    readonly hideAfter: {
        readonly type: NumberConstructor;
        readonly default: 200;
    };
    readonly teleported: {
        readonly type: BooleanConstructor;
        readonly default: true;
    };
    readonly persistent: BooleanConstructor;
    readonly width: {
        readonly type: PropType<string | number>;
        readonly default: 150;
    };
}>> & {
    onConfirm?: ((e: MouseEvent) => any) | undefined;
    onCancel?: ((e: MouseEvent) => any) | undefined;
}, {
    readonly icon: IconSlotType;
    readonly width: string | number;
    readonly persistent: boolean;
    readonly teleported: boolean;
    readonly hideAfter: number;
    readonly confirmButtonType: ButtonType;
    readonly cancelButtonType: ButtonType;
    readonly iconColor: string;
    readonly hideIcon: boolean;
}, {}>>;
export type PopconfirmInstance = InstanceType<typeof Popconfirm>;
export * from './src/interface';
export default FzPopconfirm;
